/***************************************************************************
                            kde_KConfigINIBackEnd.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KCONFIGINIBACKEND
#define KDE_KCONFIGINIBACKEND

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Class for KDE INI-style configuration file loading/saving.

 @author Preston Brown <pbrown@kde.org>,
         Matthias Kalle Dalheimer <kalle@kde.org>

 @version $Id: kde_KConfigINIBackEnd.h,v 1.4 2002/11/25 12:24:33 rdale Exp $
 
 @short *
 Class for KDE INI-style configuration file loading/saving.
*/

/** *
 Constructs an ini-style configuration back end.

*/
kde_KConfigINIBackEnd * kde_new_KConfigINIBackEnd(kde_KConfigBase* _config, qt_QString * _fileName, char* _resType, int _useKDEGlobals);

/** *
 Destructs the configuration backend.
   
*/
void kde_del_KConfigINIBackEnd( kde_KConfigINIBackEnd* p );

/** *
 Parses all INI-style configuration files for a config object.

*/
int kde_KConfigINIBackEnd_parseConfigFiles(kde_KConfigINIBackEnd* instPointer);

/** *
 Writes configuration data to file(s).

*/
void kde_KConfigINIBackEnd_sync(kde_KConfigINIBackEnd* instPointer,int bMerge);

/** *
 Parses one configuration file.

*/
//void kde_KConfigINIBackEnd_parseSingleConfigFile(kde_KConfigINIBackEnd* instPointer,qt_QFile * rFile, kde_KEntryMap* pWriteBackMap, int bGlobal, int bDefault);

/** *
 Writes configuration file back.

*/
int kde_KConfigINIBackEnd_writeConfigFile(kde_KConfigINIBackEnd* instPointer,qt_QString * filename, int bGlobal, int bMerge);
void kde_KConfigINIBackEnd_virtual_hook(kde_KConfigINIBackEnd* instPointer,int identifier, void* data);

#endif
