/***************************************************************************
                            HTMLAnchorElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 The anchor element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#edef-A"> A
 element definition </a> in HTML 4.0.

 
 @short *
 The anchor element.
*/
public class HTMLAnchorElement extends HTMLElement  {
	protected HTMLAnchorElement(Class dummy){super((Class) null);}

	private native void newHTMLAnchorElement();
	public HTMLAnchorElement() {
		super((Class) null);
		newHTMLAnchorElement();
	}
	private native void newHTMLAnchorElement( HTMLAnchorElement other);
	public HTMLAnchorElement( HTMLAnchorElement other) {
		super((Class) null);
		newHTMLAnchorElement( other);
	}
	private native void newHTMLAnchorElement( DOMNode other);
	public HTMLAnchorElement( DOMNode other) {
		super((Class) null);
		newHTMLAnchorElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
	public native String accessKey();

/** 
 see {@link accessKey}
     
*/
	public native void setAccessKey( String arg1);

/** 
 The character encoding of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-charset">
 charset attribute definition </a> in HTML 4.0.

     
*/
	public native String charset();

/** 
 see {@link charset}
     
*/
	public native void setCharset( String arg1);

/** 
 Comma-separated list of lengths, defining an active region
 geometry. See also <code> shape </code> for the shape of the
 region. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-coords">
 coords attribute definition </a> in HTML 4.0.

     
*/
	public native String coords();

/** 
 see {@link coords}
     
*/
	public native void setCoords( String arg1);

/** 
 The URI of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-href">
 href attribute definition </a> in HTML 4.0.

     
*/
	public native String href();

/** 
 see {@link href}
     
*/
	public native void setHref( String arg1);

/** 
 Language code of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-hreflang">
 hreflang attribute definition </a> in HTML 4.0.

     
*/
	public native String hreflang();

/** 
 see {@link hreflang}
     
*/
	public native void setHreflang( String arg1);

/** 
 Anchor name. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-name-A">
 name attribute definition </a> in HTML 4.0.

     
*/
	public native String name();

/** 
 see {@link name}
     
*/
	public native void setName( String arg1);

/** 
 Forward link type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-rel">
 rel attribute definition </a> in HTML 4.0.

     
*/
	public native String rel();

/** 
 see {@link rel}
     
*/
	public native void setRel( String arg1);

/** 
 Reverse link type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-rev">
 rev attribute definition </a> in HTML 4.0.

     
*/
	public native String rev();

/** 
 see {@link rev}
     
*/
	public native void setRev( String arg1);

/** 
 The shape of the active area. The coordinates are given by
 <code> coords </code> . See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-shape">
 shape attribute definition </a> in HTML 4.0.

     
*/
	public native String shape();

/** 
 see {@link shape}
     
*/
	public native void setShape( String arg1);

/** 
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
	public native long tabIndex();

/** 
 see {@link tabIndex}
     
*/
	public native void setTabIndex( long arg1);

/** 
 Frame to render the resource in. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-target">
 target attribute definition </a> in HTML 4.0.

     
*/
	public native String target();

/** 
 see {@link target}
     
*/
	public native void setTarget( String arg1);

/** 
 Advisory content type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-type-A">
 type attribute definition </a> in HTML 4.0.

     
*/
	public native String type();

/** 
 see {@link type}
     
*/
	public native void setType( String arg1);

/** 
 Removes keyboard focus from this element.

     
*/
	public native void blur();

/** 
 Gives keyboard focus to this element.

     
*/
	public native void focus();
}
