/***************************************************************************
                            HTMLAreaElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Client-side image map area definition. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#edef-AREA">
 AREA element definition </a> in HTML 4.0.

 
 @short *
 Client-side image map area definition.
*/
public class HTMLAreaElement extends HTMLElement  {
	protected HTMLAreaElement(Class dummy){super((Class) null);}

	private native void newHTMLAreaElement();
	public HTMLAreaElement() {
		super((Class) null);
		newHTMLAreaElement();
	}
	private native void newHTMLAreaElement( HTMLAreaElement other);
	public HTMLAreaElement( HTMLAreaElement other) {
		super((Class) null);
		newHTMLAreaElement( other);
	}
	private native void newHTMLAreaElement( DOMNode other);
	public HTMLAreaElement( DOMNode other) {
		super((Class) null);
		newHTMLAreaElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
	public native String accessKey();

/** 
 see {@link accessKey}
     
*/
	public native void setAccessKey( String arg1);

/** 
 Alternate text for user agents not rendering the normal content
 of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-alt">
 alt attribute definition </a> in HTML 4.0.

     
*/
	public native String alt();

/** 
 see {@link alt}
     
*/
	public native void setAlt( String arg1);

/** 
 Comma-separated list of lengths, defining an active region
 geometry. See also <code> shape </code> for the shape of the
 region. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-coords">
 coords attribute definition </a> in HTML 4.0.

     
*/
	public native String coords();

/** 
 see {@link coords}
     
*/
	public native void setCoords( String arg1);

/** 
 The URI of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-href">
 href attribute definition </a> in HTML 4.0.

     
*/
	public native String href();

/** 
 see {@link href}
     
*/
	public native void setHref( String arg1);

/** 
 Specifies that this area is inactive, i.e., has no associated
 action. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-nohref">
 nohref attribute definition </a> in HTML 4.0.

     
*/
	public native boolean noHref();

/** 
 see {@link noHref}
     
*/
	public native void setNoHref( boolean arg1);

/** 
 The shape of the active area. The coordinates are given by
 <code> coords </code> . See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-shape">
 shape attribute definition </a> in HTML 4.0.

     
*/
	public native String shape();

/** 
 see {@link shape}
     
*/
	public native void setShape( String arg1);

/** 
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
	public native long tabIndex();

/** 
 see {@link tabIndex}
     
*/
	public native void setTabIndex( long arg1);

/** 
 Frame to render the resource in. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-target">
 target attribute definition </a> in HTML 4.0.

     
*/
	public native String target();

/** 
 see {@link target}
     
*/
	public native void setTarget( String arg1);
}
