/***************************************************************************
                            HTMLBodyElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 The HTML document body. This element is always present in the DOM
 API, even if the tags are not present in the source document. See
 the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#edef-BODY">
 BODY element definition </a> in HTML 4.0.

 
 @short *
 The HTML document body.
*/
public class HTMLBodyElement extends HTMLElement  {
	protected HTMLBodyElement(Class dummy){super((Class) null);}

	private native void newHTMLBodyElement();
	public HTMLBodyElement() {
		super((Class) null);
		newHTMLBodyElement();
	}
	private native void newHTMLBodyElement( HTMLBodyElement other);
	public HTMLBodyElement( HTMLBodyElement other) {
		super((Class) null);
		newHTMLBodyElement( other);
	}
	private native void newHTMLBodyElement( DOMNode other);
	public HTMLBodyElement( DOMNode other) {
		super((Class) null);
		newHTMLBodyElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 Color of active links (after mouse-button down, but before
 mouse-button up). See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-alink">
 alink attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String aLink();

/** 
 see {@link aLink}
     
*/
	public native void setALink( String arg1);

/** 
 URI of the background texture tile image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-background">
 background attribute definition </a> in HTML 4.0. This
 attribute is deprecated in HTML 4.0.

     
*/
	public native String background();

/** 
 see {@link background}
     
*/
	public native void setBackground( String arg1);

/** 
 Document background color. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-bgcolor">
 bgcolor attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
	public native String bgColor();

/** 
 see {@link bgColor}
     
*/
	public native void setBgColor( String arg1);

/** 
 Color of links that are not active and unvisited. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-link">
 link attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String link();

/** 
 see {@link link}
     
*/
	public native void setLink( String arg1);

/** 
 Document text color. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-text">
 text attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String text();

/** 
 see {@link text}
     
*/
	public native void setText( String arg1);

/** 
 Color of links that have been visited by the user. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-vlink">
 vlink attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String vLink();

/** 
 see {@link vLink}
     
*/
	public native void setVLink( String arg1);
}
