/***************************************************************************
                            HTMLButtonElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Push button. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#edef-BUTTON">
 BUTTON element definition </a> in HTML 4.0.

 
 @short *
 Push button.
*/
public class HTMLButtonElement extends HTMLElement  {
	protected HTMLButtonElement(Class dummy){super((Class) null);}

	private native void newHTMLButtonElement();
	public HTMLButtonElement() {
		super((Class) null);
		newHTMLButtonElement();
	}
	private native void newHTMLButtonElement( HTMLButtonElement other);
	public HTMLButtonElement( HTMLButtonElement other) {
		super((Class) null);
		newHTMLButtonElement( other);
	}
	private native void newHTMLButtonElement( DOMNode other);
	public HTMLButtonElement( DOMNode other) {
		super((Class) null);
		newHTMLButtonElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 Returns the <code> FORM </code> element containing this
 control. Returns null if this control is not within the context
 of a form.

     
*/
	public native HTMLFormElement form();

/** 
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
	public native String accessKey();

/** 
 see {@link accessKey}
     
*/
	public native void setAccessKey( String arg1);

/** 
 The control is unavailable in this context. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-disabled">
 disabled attribute definition </a> in HTML 4.0.

     
*/
	public native boolean disabled();

/** 
 see {@link disabled}
     
*/
	public native void setDisabled( boolean arg1);

/** 
 Form control or object name when submitted with a form. See the
 <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-name-BUTTON">
 name attribute definition </a> in HTML 4.0.

     
*/
	public native String name();

/** 
 see {@link name}
     
*/
	public native void setName( String arg1);

/** 
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
	public native long tabIndex();

/** 
 see {@link tabIndex}
     
*/
	public native void setTabIndex( long arg1);

/** 
 The type of button. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-type-BUTTON">
 type attribute definition </a> in HTML 4.0.

     
*/
	public native String type();

/** 
 The current form control value. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-value-BUTTON">
 value attribute definition </a> in HTML 4.0.

     
*/
	public native String value();

/** 
 see {@link value}
     
*/
	public native void setValue( String arg1);
}
