/***************************************************************************
                            HTMLFrameSetElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Create a grid of frames. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#edef-FRAMESET">
 FRAMESET element definition </a> in HTML 4.0.

 
 @short *
 Create a grid of frames.
*/
public class HTMLFrameSetElement extends HTMLElement  {
	protected HTMLFrameSetElement(Class dummy){super((Class) null);}

	private native void newHTMLFrameSetElement();
	public HTMLFrameSetElement() {
		super((Class) null);
		newHTMLFrameSetElement();
	}
	private native void newHTMLFrameSetElement( HTMLFrameSetElement other);
	public HTMLFrameSetElement( HTMLFrameSetElement other) {
		super((Class) null);
		newHTMLFrameSetElement( other);
	}
	private native void newHTMLFrameSetElement( DOMNode other);
	public HTMLFrameSetElement( DOMNode other) {
		super((Class) null);
		newHTMLFrameSetElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 The number of columns of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-cols-FRAMESET">
 cols attribute definition </a> in HTML 4.0.

     
*/
	public native String cols();

/** 
 see {@link cols}
     
*/
	public native void setCols( String arg1);

/** 
 The number of rows of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-rows-FRAMESET">
 rows attribute definition </a> in HTML 4.0.

     
*/
	public native String rows();

/** 
 see {@link rows}
     
*/
	public native void setRows( String arg1);
}
