/***************************************************************************
                            HTMLHRElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Create a horizontal rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#edef-HR">
 HR element definition </a> in HTML 4.0.

 
 @short *
 Create a horizontal rule.
*/
public class HTMLHRElement extends HTMLElement  {
	protected HTMLHRElement(Class dummy){super((Class) null);}

	private native void newHTMLHRElement();
	public HTMLHRElement() {
		super((Class) null);
		newHTMLHRElement();
	}
	private native void newHTMLHRElement( HTMLHRElement other);
	public HTMLHRElement( HTMLHRElement other) {
		super((Class) null);
		newHTMLHRElement( other);
	}
	private native void newHTMLHRElement( DOMNode other);
	public HTMLHRElement( DOMNode other) {
		super((Class) null);
		newHTMLHRElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 Align the rule on the page. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-align-HR">
 align attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String align();

/** 
 see {@link align}
     
*/
	public native void setAlign( String arg1);

/** 
 Indicates to the user agent that there should be no shading in
 the rendering of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-noshade">
 noshade attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
	public native boolean noShade();

/** 
 see {@link noShade}
     
*/
	public native void setNoShade( boolean arg1);

/** 
 The height of the rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-size-HR">
 size attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String size();

/** 
 see {@link size}
     
*/
	public native void setSize( String arg1);

/** 
 The width of the rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-width-HR">
 width attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String width();

/** 
 see {@link width}
     
*/
	public native void setWidth( String arg1);
}
