/***************************************************************************
                            HTMLImageElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Embedded image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#edef-IMG">
 IMG element definition </a> in HTML 4.0.

 
 @short *
 Embedded image.
*/
public class HTMLImageElement extends HTMLElement  {
	protected HTMLImageElement(Class dummy){super((Class) null);}

	private native void newHTMLImageElement();
	public HTMLImageElement() {
		super((Class) null);
		newHTMLImageElement();
	}
	private native void newHTMLImageElement( HTMLImageElement other);
	public HTMLImageElement( HTMLImageElement other) {
		super((Class) null);
		newHTMLImageElement( other);
	}
	private native void newHTMLImageElement( DOMNode other);
	public HTMLImageElement( DOMNode other) {
		super((Class) null);
		newHTMLImageElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 The name of the element (for backwards compatibility).

     
*/
	public native String name();

/** 
 see {@link name}
     
*/
	public native void setName( String arg1);

/** 
 Aligns this object (vertically or horizontally) with respect to
 its surrounding text. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-align-IMG">
 align attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String align();

/** 
 see {@link align}
     
*/
	public native void setAlign( String arg1);

/** 
 Alternate text for user agents not rendering the normal content
 of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-alt">
 alt attribute definition </a> in HTML 4.0.

     
*/
	public native String alt();

/** 
 see {@link alt}
     
*/
	public native void setAlt( String arg1);

/** 
 Width of border around image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-border-IMG">
 border attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native long border();

/** 
 see {@link border}
     
*/
	public native void setBorder( long arg1);

/** 
 Override height. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-height-IMG">
 height attribute definition </a> in HTML 4.0.

     
*/
	public native long height();

/** 
 see {@link height}
     
*/
	public native void setHeight( long arg1);

/** 
 Horizontal space to the left and right of this image. See the
 <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-hspace">
 hspace attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native long hspace();

/** 
 see {@link hspace}
     
*/
	public native void setHspace( long arg1);

/** 
 Use server-side image map. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-ismap">
 ismap attribute definition </a> in HTML 4.0.

     
*/
	public native boolean isMap();

/** 
 see {@link isMap}
     
*/
	public native void setIsMap( boolean arg1);

/** 
 URI designating a long description of this image or frame. See
 the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-longdesc-IMG">
 longdesc attribute definition </a> in HTML 4.0.

     
*/
	public native String longDesc();

/** 
 see {@link longDesc}
     
*/
	public native void setLongDesc( String arg1);

/** 
 URI designating the source of this image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-src-IMG">
 src attribute definition </a> in HTML 4.0.

     
*/
	public native String src();

/** 
 see {@link src}
     
*/
	public native void setSrc( String arg1);

/** 
 Use client-side image map. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-usemap">
 usemap attribute definition </a> in HTML 4.0.

     
*/
	public native String useMap();

/** 
 see {@link useMap}
     
*/
	public native void setUseMap( String arg1);

/** 
 Vertical space above and below this image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-vspace">
 vspace attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native long vspace();

/** 
 see {@link vspace}
     
*/
	public native void setVspace( long arg1);

/** 
 Override width. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-width-IMG">
 width attribute definition </a> in HTML 4.0.

     
*/
	public native long width();

/** 
 see {@link width}
     
*/
	public native void setWidth( long arg1);
}
