/***************************************************************************
                            HTMLScriptElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Script statements. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#edef-SCRIPT">
 SCRIPT element definition </a> in HTML 4.0.

 
 @short *
 Script statements.
*/
public class HTMLScriptElement extends HTMLElement  {
	protected HTMLScriptElement(Class dummy){super((Class) null);}

	private native void newHTMLScriptElement();
	public HTMLScriptElement() {
		super((Class) null);
		newHTMLScriptElement();
	}
	private native void newHTMLScriptElement( HTMLScriptElement other);
	public HTMLScriptElement( HTMLScriptElement other) {
		super((Class) null);
		newHTMLScriptElement( other);
	}
	private native void newHTMLScriptElement( DOMNode other);
	public HTMLScriptElement( DOMNode other) {
		super((Class) null);
		newHTMLScriptElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 The script content of the element.

     
*/
	public native String text();

/** 
 see {@link text}
     
*/
	public native void setText( String arg1);

/** 
 Reserved for future use.

     
*/
	public native String htmlFor();

/** 
 see {@link htmlFor}
     
*/
	public native void setHtmlFor( String arg1);

/** 
 Reserved for future use.

     
*/
	public native String event();

/** 
 see {@link event}
     
*/
	public native void setEvent( String arg1);

/** 
 The character encoding of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-charset">
 charset attribute definition </a> in HTML 4.0.

     
*/
	public native String charset();

/** 
 see {@link charset}
     
*/
	public native void setCharset( String arg1);

/** 
 Indicates that the user agent can defer processing of the
 script. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-defer">
 defer attribute definition </a> in HTML 4.0.

     
*/
	public native boolean defer();

/** 
 see {@link defer}
     
*/
	public native void setDefer( boolean arg1);

/** 
 URI designating an external script. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-src-SCRIPT">
 src attribute definition </a> in HTML 4.0.

     
*/
	public native String src();

/** 
 see {@link src}
     
*/
	public native void setSrc( String arg1);

/** 
 The content type of the script language. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-type-SCRIPT">
 type attribute definition </a> in HTML 4.0.

     
*/
	public native String type();

/** 
 see {@link type}
     
*/
	public native void setType( String arg1);
}
