package org.kde.koala;
import org.kde.qt.*;


/** {@link KListBox} emits these signals */
public interface KListBoxSignals {
	void pressed( QListBoxItem arg1, QPoint arg2 );
	void verticalSliderPressed();
	void horizontalSliderPressed();

/** 
 Emitted whenever the user executes an listbox item. 

 That means depending on the KDE wide Single Click/Double Click 
 setting the user clicked or double clicked on that item.

 Note that you may not delete any {@link QListBoxItem} objects in slots 
 connected to this signal.
   
*/
	void executed( QListBoxItem item, QPoint pos );
	void rightButtonClicked( QListBoxItem arg1, QPoint arg2 );
	void rightButtonPressed( QListBoxItem arg1, QPoint arg2 );
	void onViewport();
	void onItem( QListBoxItem item );
	void returnPressed( QListBoxItem arg1 );
	void contentsMoving( int x, int y );
	void currentChanged( QListBoxItem arg1 );
	void selected( QListBoxItem arg1 );
	void destroyed( QObject obj );
	void contextMenuRequested( QListBoxItem arg1, QPoint arg2 );
	void verticalSliderReleased();
	void selectionChanged( QListBoxItem arg1 );

/** 
 This signal gets emitted whenever the user double clicks into the 
 listbox. 

 Note that you may not delete any {@link QListBoxItem} objects in slots
 connected to this signal.  

 This signal is more or less here for the sake of completeness.
 You should normally not need to use this. In most cases its better 
 to use {@link KListBox#executed} instead.
   
*/
	void doubleClicked( QListBoxItem item, QPoint pos );
	void horizontalSliderReleased();
	void highlighted( QListBoxItem arg1 );
	void mouseButtonClicked( int arg1, QListBoxItem arg2, QPoint arg3 );
	void mouseButtonPressed( int arg1, QListBoxItem arg2, QPoint arg3 );
	void clicked( QListBoxItem arg1, QPoint arg2 );
}

