/***************************************************************************
                            KTipDatabase.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 A database for tips-of-the-day.

 This class provides convenient access to a database containing
 tips of the day. The database is stored in a XML file and parsed
 when a KTipDatabase object is created.

 Once the file is read in, you can access the tips to display
 them in the tip of the day dialog.

 The state of the tipdialog is saved to the applications's config file
 in the group "TipOfDay" with a boolean entry "RunOnStart". Check this value
 if you want to allow the user to enable/disable the tipdialog in the
 application's configuration dialog.

 
 @author Matthias Hoelzer-Kluepfel <mhk@caldera.de>

 @short *
 A database for tips-of-the-day.
*/
public class  KTipDatabase implements QtSupport {
	private long _qt;
	private boolean _allocatedInJavaWorld = true;

	protected KTipDatabase(Class dummy){}

	private native void newKTipDatabase( String tipFile);

/** 
 The constructor.

 This reads in the tips from a file with the given name. If no name is
 given, a file called 'application-name/tips' will be loaded.

*/
	public KTipDatabase( String tipFile) {
		newKTipDatabase( tipFile);
	}
	private native void newKTipDatabase();
	public KTipDatabase() {
		newKTipDatabase();
	}

/** 
 Returns the current tip.
     
*/
	public native String tip();

/** 
 The next tip will become the current one.
     
*/
	public native void nextTip();

/** 
 The previous tip will become the current one.
     
*/
	public native void prevTip();
}
