/**
 * @libdoc Framework for embedding the KJS Javascript Interpreter
 *
 * This library provides a framework that makes it easy for applications
 * to embed KJS, the KDE JavaScript interpreter. The facilities available
 * include a JS console widget, a dialog loader and a binding between JS
 * and the properties of a QObject.
 * 
 * The main classes are:
 *
 * @ref JSObjectProxy :
 *   A Javascript object that can access the properties of a QObject,
 *
 * @ref JSHookLoader :
 *   Loads JS commands from a KConfig file.
 *
 * @ref JSConsoleWidget :
 *   A widget that provides an interactive JS console.
 *
 * @ref JSConsolePart :
 *   A KPart wrapper for @ref JSConsoleWidget .
 *
 * @ref MessageLogWidget :
 *   A widget providing a colorised message log.
 */
