/***************************************************************************
                            Qt.java -  description
                             -------------------
    begin                : Sun Nov  3 10:27:27 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov  3 10:27:27 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.qt;

import java.util.*;
import java.io.*;
import java.lang.Error;
import java.text.MessageFormat;
import java.lang.reflect.*;

public class  Qt implements QtSupport {
	private long _qt;
	private boolean _allocatedInJavaWorld = true;

	protected Qt(Class dummy){}
		
	/** This member allows a typecast of an instance which wraps a Qt instance,
		to a more specialized type. Invokes the private qtjava.dynamicCast()
		via reflection, as that method isn't part of the public Qt api */
	public static QtSupport dynamicCast(String type, QtSupport source) {
		Method		method = null;
		
		try {
			method = qtjava.class.getDeclaredMethod(	"dynamicCast",
														new Class[] { String.class, QtSupport.class } );
		} catch (NoSuchMethodException e1) {
			Qt.qWarning("No such method : qtjava.dynamicCast()");
		}

		try {
			method.setAccessible(true);
			Object result = method.invoke(qtjava.class, new Object[] { type, source } );
			return (QtSupport) result;
		} catch (InvocationTargetException e) {
			Qt.qWarning("Invocation failed : qtjava.dynamicCast()");
			return null;
		} catch (IllegalAccessException e) {
			Qt.qWarning("Invocation failed : qtjava.dynamicCast()");
			return null;
		}
	}
	
	
	public static native QColor color0();
	public static native QColor color1();
	public static native QColor black();
	public static native QColor white();
	public static native QColor darkGray();
	public static native QColor gray();
	public static native QColor lightGray();
	public static native QColor red();
	public static native QColor green();
	public static native QColor blue();
	public static native QColor cyan();
	public static native QColor magenta();
	public static native QColor yellow();
	public static native QColor darkRed();
	public static native QColor darkGreen();
	public static native QColor darkBlue();
	public static native QColor darkCyan();
	public static native QColor darkMagenta();
	public static native QColor darkYellow();
	
    // Global cursors

	public static native QCursor arrowCursor();	// standard arrow cursor
	public static native QCursor upArrowCursor();	// upwards arrow
	public static native QCursor crossCursor();	// crosshair
	public static native QCursor waitCursor();	// hourglass/watch
	public static native QCursor ibeamCursor();	// ibeam/text entry
	public static native QCursor sizeVerCursor();	// vertical resize
	public static native QCursor sizeHorCursor();	// horizontal resize
	public static native QCursor sizeBDiagCursor();	// diagonal resize (/)
	public static native QCursor sizeFDiagCursor();	// diagonal resize (\)
	public static native QCursor sizeAllCursor();	// all directions resize
	public static native QCursor blankCursor();	// blank/invisible cursor
	public static native QCursor splitVCursor();	// vertical bar with left-right
						// arrows
	public static native QCursor splitHCursor();	// horizontal bar with up-down
						// arrows
	public static native QCursor pointingHandCursor();	// pointing hand
	public static native QCursor forbiddenCursor();	// forbidden cursor (slashed circle)
	
	public static native QApplication qApp();
	
	public static native void qDebug(String message);
	public static void qDebug(String pattern, Object[] arguments) {
		qDebug(MessageFormat.format(pattern, arguments));
	}
	
	public static native void qWarning(String message);
	public static void qWarning(String pattern, Object[] arguments) {
		qWarning(MessageFormat.format(pattern, arguments));
	}
	
	public static native void qFatal(String message);
	public static void qFatal(String pattern, Object[] arguments) {
		qFatal(MessageFormat.format(pattern, arguments));
	}
	
	/** From 'The Java Programming Language, Third Edition', page 219 */
	private static String sqeezeOut(String from, char toss) {
		char[] chars = from.toCharArray();
		int len = chars.length;
		int put = 0;
		
		for (int i = 0; i < len; i++) {
			if (chars[i] != toss) {
				chars[put++] = chars[i];
			}
		}
		
		return new String(chars, 0, put);
	}
	
	/** Prepend a '2' to a signal string and remove any spaces */
	public static String SIGNAL(String signal) {
		return "2" + sqeezeOut(signal, ' ');
	}
	
	/** Prepend a '1' to a slot string and remove any spaces */
	public static String SLOT(String slot) {
		return "1" + sqeezeOut(slot, ' ');
	}
	
	/** Convert from a UTF-8 string to Unicode - the java equivalent to QString::fromUtf8() */
	public String fromUtf8(byte[] bytes) {
		String result = null;
		
		try {
			result = new String(bytes, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			qWarning("UTF-8 encoding not supported");
		} finally {
			return result;
		}
	}
	
	public static final int NoButton = 0x0000;
	public static final int LeftButton = 0x0001;
	public static final int RightButton = 0x0002;
	public static final int MidButton = 0x0004;
	public static final int MouseButtonMask = 0x0007;
	public static final int ShiftButton = 0x0100;
	public static final int ControlButton = 0x0200;
	public static final int AltButton = 0x0400;
	public static final int MetaButton = 0x0800;
	public static final int KeyButtonMask = 0x0f00;
	public static final int Keypad = 0x4000;
	public static final int Horizontal = 0;
	public static final int Vertical = 1;
	public static final int AlignAuto = 0x0000;
	public static final int AlignLeft = 0x0001;
	public static final int AlignRight = 0x0002;
	public static final int AlignHCenter = 0x0004;
	public static final int AlignJustify = 0x0008;
	public static final int AlignHorizontal_Mask = AlignLeft|AlignRight|AlignHCenter|AlignJustify;
	public static final int AlignTop = 0x0010;
	public static final int AlignBottom = 0x0020;
	public static final int AlignVCenter = 0x0040;
	public static final int AlignVertical_Mask = AlignTop|AlignBottom|AlignVCenter;
	public static final int AlignCenter = AlignVCenter|AlignHCenter;
	public static final int SingleLine = 0x0080;
	public static final int DontClip = 0x0100;
	public static final int ExpandTabs = 0x0200;
	public static final int ShowPrefix = 0x0400;
	public static final int WordBreak = 0x0800;
	public static final int BreakAnywhere = 0x1000;
	public static final int DontPrint = 0x2000;
	public static final int NoAccel = 0x4000;
	public static final int WState_Created = 0x00000001;
	public static final int WState_Disabled = 0x00000002;
	public static final int WState_Visible = 0x00000004;
	public static final int WState_ForceHide = 0x00000008;
	public static final int WState_OwnCursor = 0x00000010;
	public static final int WState_MouseTracking = 0x00000020;
	public static final int WState_CompressKeys = 0x00000040;
	public static final int WState_BlockUpdates = 0x00000080;
	public static final int WState_InPaintEvent = 0x00000100;
	public static final int WState_Reparented = 0x00000200;
	public static final int WState_ConfigPending = 0x00000400;
	public static final int WState_Resized = 0x00000800;
	public static final int WState_AutoMask = 0x00001000;
	public static final int WState_Polished = 0x00002000;
	public static final int WState_DND = 0x00004000;
	public static final int WState_Reserved0 = 0x00008000;
	public static final int WState_Reserved1 = 0x00010000;
	public static final int WState_Reserved2 = 0x00020000;
	public static final int WState_CreatedHidden = 0x00040000;
	public static final int WState_Maximized = 0x00080000;
	public static final int WState_Minimized = 0x00100000;
	public static final int WState_ForceDisabled = 0x00200000;
	public static final int WState_Exposed = 0x00400000;
	public static final int WState_HasMouse = 0x00800000;
	public static final int WType_TopLevel = 0x00000001;
	public static final int WType_Dialog = 0x00000002;
	public static final int WType_Popup = 0x00000004;
	public static final int WType_Desktop = 0x00000008;
	public static final int WType_Mask = 0x0000000f;
	public static final int WStyle_Customize = 0x00000010;
	public static final int WStyle_NormalBorder = 0x00000020;
	public static final int WStyle_DialogBorder = 0x00000040;
	public static final int WStyle_NoBorder = 0x00002000;
	public static final int WStyle_Title = 0x00000080;
	public static final int WStyle_SysMenu = 0x00000100;
	public static final int WStyle_Minimize = 0x00000200;
	public static final int WStyle_Maximize = 0x00000400;
	public static final int WStyle_MinMax = WStyle_Minimize|WStyle_Maximize;
	public static final int WStyle_Tool = 0x00000800;
	public static final int WStyle_StaysOnTop = 0x00001000;
	public static final int WStyle_ContextHelp = 0x00004000;
	public static final int WStyle_Reserved = 0x00008000;
	public static final int WStyle_Mask = 0x0000fff0;
	public static final int WDestructiveClose = 0x00010000;
	public static final int WPaintDesktop = 0x00020000;
	public static final int WPaintUnclipped = 0x00040000;
	public static final int WPaintClever = 0x00080000;
	public static final int WResizeNoErase = 0x00100000;
	public static final int WMouseNoMask = 0x00200000;
	public static final int WStaticContents = 0x00400000;
	public static final int WRepaintNoErase = 0x00800000;
	public static final int WGroupLeader = 0x02000000;
	public static final int WShowModal = 0x04000000;
	public static final int WNoMousePropagation = 0x08000000;
	public static final int WSubWindow = 0x10000000;
//	public static final int WStyle_Splash = WStyle_NoBorder|WStyle_StaysOnTop|WStyle_Tool|WX11BypassWM|WWinOwnDC;
	public static final int WNorthWestGravity = WStaticContents;
	public static final int WType_Modal = WType_Dialog|WShowModal;
	public static final int WStyle_Dialog = WType_Dialog;
	public static final int WStyle_NoBorderEx = WStyle_NoBorder;
	public static final int ColorMode_Mask = 0x00000003;
	public static final int AutoColor = 0x00000000;
	public static final int ColorOnly = 0x00000003;
	public static final int MonoOnly = 0x00000002;
	public static final int AlphaDither_Mask = 0x0000000c;
	public static final int ThresholdAlphaDither = 0x00000000;
	public static final int OrderedAlphaDither = 0x00000004;
	public static final int DiffuseAlphaDither = 0x00000008;
	public static final int NoAlpha = 0x0000000c;
	public static final int Dither_Mask = 0x00000030;
	public static final int DiffuseDither = 0x00000000;
	public static final int OrderedDither = 0x00000010;
	public static final int ThresholdDither = 0x00000020;
	public static final int DitherMode_Mask = 0x000000c0;
	public static final int AutoDither = 0x00000000;
	public static final int PreferDither = 0x00000040;
	public static final int AvoidDither = 0x00000080;
	public static final int TransparentMode = 0;
	public static final int OpaqueMode = 1;
	public static final int PixelUnit = 0;
	public static final int LoMetricUnit = 1;
	public static final int HiMetricUnit = 2;
	public static final int LoEnglishUnit = 3;
	public static final int HiEnglishUnit = 4;
	public static final int TwipsUnit = 5;
	public static final int WindowsStyle = 1;
	public static final int MotifStyle = 4;
	public static final int MacStyle = 0;
//	public static final int WindowsStyle = 1;
	public static final int Win3Style = 2;
	public static final int PMStyle = 3;
//	public static final int MotifStyle = 4;
	public static final int NoMatch = 0;
	public static final int PartialMatch = 1;
	public static final int Identical = 2;
	public static final int META = 0x00100000;
	public static final int SHIFT = 0x00200000;
	public static final int CTRL = 0x00400000;
	public static final int ALT = 0x00800000;
	public static final int MODIFIER_MASK = 0x00f00000;
	public static final int UNICODE_ACCEL = 0x10000000;
	public static final int ASCII_ACCEL = UNICODE_ACCEL;
	public static final int Key_Escape = 0x1000;
	public static final int Key_Tab = 0x1001;
	public static final int Key_Backtab = 0x1002;
	public static final int Key_BackTab = Key_Backtab;
	public static final int Key_Backspace = 0x1003;
	public static final int Key_BackSpace = Key_Backspace;
	public static final int Key_Return = 0x1004;
	public static final int Key_Enter = 0x1005;
	public static final int Key_Insert = 0x1006;
	public static final int Key_Delete = 0x1007;
	public static final int Key_Pause = 0x1008;
	public static final int Key_Print = 0x1009;
	public static final int Key_SysReq = 0x100a;
	public static final int Key_Clear = 0x100b;
	public static final int Key_Home = 0x1010;
	public static final int Key_End = 0x1011;
	public static final int Key_Left = 0x1012;
	public static final int Key_Up = 0x1013;
	public static final int Key_Right = 0x1014;
	public static final int Key_Down = 0x1015;
	public static final int Key_Prior = 0x1016;
	public static final int Key_PageUp = Key_Prior;
	public static final int Key_Next = 0x1017;
	public static final int Key_PageDown = Key_Next;
	public static final int Key_Shift = 0x1020;
	public static final int Key_Control = 0x1021;
	public static final int Key_Meta = 0x1022;
	public static final int Key_Alt = 0x1023;
	public static final int Key_CapsLock = 0x1024;
	public static final int Key_NumLock = 0x1025;
	public static final int Key_ScrollLock = 0x1026;
	public static final int Key_F1 = 0x1030;
	public static final int Key_F2 = 0x1031;
	public static final int Key_F3 = 0x1032;
	public static final int Key_F4 = 0x1033;
	public static final int Key_F5 = 0x1034;
	public static final int Key_F6 = 0x1035;
	public static final int Key_F7 = 0x1036;
	public static final int Key_F8 = 0x1037;
	public static final int Key_F9 = 0x1038;
	public static final int Key_F10 = 0x1039;
	public static final int Key_F11 = 0x103a;
	public static final int Key_F12 = 0x103b;
	public static final int Key_F13 = 0x103c;
	public static final int Key_F14 = 0x103d;
	public static final int Key_F15 = 0x103e;
	public static final int Key_F16 = 0x103f;
	public static final int Key_F17 = 0x1040;
	public static final int Key_F18 = 0x1041;
	public static final int Key_F19 = 0x1042;
	public static final int Key_F20 = 0x1043;
	public static final int Key_F21 = 0x1044;
	public static final int Key_F22 = 0x1045;
	public static final int Key_F23 = 0x1046;
	public static final int Key_F24 = 0x1047;
	public static final int Key_F25 = 0x1048;
	public static final int Key_F26 = 0x1049;
	public static final int Key_F27 = 0x104a;
	public static final int Key_F28 = 0x104b;
	public static final int Key_F29 = 0x104c;
	public static final int Key_F30 = 0x104d;
	public static final int Key_F31 = 0x104e;
	public static final int Key_F32 = 0x104f;
	public static final int Key_F33 = 0x1050;
	public static final int Key_F34 = 0x1051;
	public static final int Key_F35 = 0x1052;
	public static final int Key_Super_L = 0x1053;
	public static final int Key_Super_R = 0x1054;
	public static final int Key_Menu = 0x1055;
	public static final int Key_Hyper_L = 0x1056;
	public static final int Key_Hyper_R = 0x1057;
	public static final int Key_Help = 0x1058;
	public static final int Key_Direction_L = 0x1059;
	public static final int Key_Direction_R = 0x1060;
	public static final int Key_Space = 0x20;
	public static final int Key_Any = Key_Space;
	public static final int Key_Exclam = 0x21;
	public static final int Key_QuoteDbl = 0x22;
	public static final int Key_NumberSign = 0x23;
	public static final int Key_Dollar = 0x24;
	public static final int Key_Percent = 0x25;
	public static final int Key_Ampersand = 0x26;
	public static final int Key_Apostrophe = 0x27;
	public static final int Key_ParenLeft = 0x28;
	public static final int Key_ParenRight = 0x29;
	public static final int Key_Asterisk = 0x2a;
	public static final int Key_Plus = 0x2b;
	public static final int Key_Comma = 0x2c;
	public static final int Key_Minus = 0x2d;
	public static final int Key_Period = 0x2e;
	public static final int Key_Slash = 0x2f;
	public static final int Key_0 = 0x30;
	public static final int Key_1 = 0x31;
	public static final int Key_2 = 0x32;
	public static final int Key_3 = 0x33;
	public static final int Key_4 = 0x34;
	public static final int Key_5 = 0x35;
	public static final int Key_6 = 0x36;
	public static final int Key_7 = 0x37;
	public static final int Key_8 = 0x38;
	public static final int Key_9 = 0x39;
	public static final int Key_Colon = 0x3a;
	public static final int Key_Semicolon = 0x3b;
	public static final int Key_Less = 0x3c;
	public static final int Key_Equal = 0x3d;
	public static final int Key_Greater = 0x3e;
	public static final int Key_Question = 0x3f;
	public static final int Key_At = 0x40;
	public static final int Key_A = 0x41;
	public static final int Key_B = 0x42;
	public static final int Key_C = 0x43;
	public static final int Key_D = 0x44;
	public static final int Key_E = 0x45;
	public static final int Key_F = 0x46;
	public static final int Key_G = 0x47;
	public static final int Key_H = 0x48;
	public static final int Key_I = 0x49;
	public static final int Key_J = 0x4a;
	public static final int Key_K = 0x4b;
	public static final int Key_L = 0x4c;
	public static final int Key_M = 0x4d;
	public static final int Key_N = 0x4e;
	public static final int Key_O = 0x4f;
	public static final int Key_P = 0x50;
	public static final int Key_Q = 0x51;
	public static final int Key_R = 0x52;
	public static final int Key_S = 0x53;
	public static final int Key_T = 0x54;
	public static final int Key_U = 0x55;
	public static final int Key_V = 0x56;
	public static final int Key_W = 0x57;
	public static final int Key_X = 0x58;
	public static final int Key_Y = 0x59;
	public static final int Key_Z = 0x5a;
	public static final int Key_BracketLeft = 0x5b;
	public static final int Key_Backslash = 0x5c;
	public static final int Key_BracketRight = 0x5d;
	public static final int Key_AsciiCircum = 0x5e;
	public static final int Key_Underscore = 0x5f;
	public static final int Key_QuoteLeft = 0x60;
	public static final int Key_BraceLeft = 0x7b;
	public static final int Key_Bar = 0x7c;
	public static final int Key_BraceRight = 0x7d;
	public static final int Key_AsciiTilde = 0x7e;
	public static final int Key_nobreakspace = 0x0a0;
	public static final int Key_exclamdown = 0x0a1;
	public static final int Key_cent = 0x0a2;
	public static final int Key_sterling = 0x0a3;
	public static final int Key_currency = 0x0a4;
	public static final int Key_yen = 0x0a5;
	public static final int Key_brokenbar = 0x0a6;
	public static final int Key_section = 0x0a7;
	public static final int Key_diaeresis = 0x0a8;
	public static final int Key_copyright = 0x0a9;
	public static final int Key_ordfeminine = 0x0aa;
	public static final int Key_guillemotleft = 0x0ab;
	public static final int Key_notsign = 0x0ac;
	public static final int Key_hyphen = 0x0ad;
	public static final int Key_registered = 0x0ae;
	public static final int Key_macron = 0x0af;
	public static final int Key_degree = 0x0b0;
	public static final int Key_plusminus = 0x0b1;
	public static final int Key_twosuperior = 0x0b2;
	public static final int Key_threesuperior = 0x0b3;
	public static final int Key_acute = 0x0b4;
	public static final int Key_mu = 0x0b5;
	public static final int Key_paragraph = 0x0b6;
	public static final int Key_periodcentered = 0x0b7;
	public static final int Key_cedilla = 0x0b8;
	public static final int Key_onesuperior = 0x0b9;
	public static final int Key_masculine = 0x0ba;
	public static final int Key_guillemotright = 0x0bb;
	public static final int Key_onequarter = 0x0bc;
	public static final int Key_onehalf = 0x0bd;
	public static final int Key_threequarters = 0x0be;
	public static final int Key_questiondown = 0x0bf;
	public static final int Key_Agrave = 0x0c0;
	public static final int Key_Aacute = 0x0c1;
	public static final int Key_Acircumflex = 0x0c2;
	public static final int Key_Atilde = 0x0c3;
	public static final int Key_Adiaeresis = 0x0c4;
	public static final int Key_Aring = 0x0c5;
	public static final int Key_AE = 0x0c6;
	public static final int Key_Ccedilla = 0x0c7;
	public static final int Key_Egrave = 0x0c8;
	public static final int Key_Eacute = 0x0c9;
	public static final int Key_Ecircumflex = 0x0ca;
	public static final int Key_Ediaeresis = 0x0cb;
	public static final int Key_Igrave = 0x0cc;
	public static final int Key_Iacute = 0x0cd;
	public static final int Key_Icircumflex = 0x0ce;
	public static final int Key_Idiaeresis = 0x0cf;
	public static final int Key_ETH = 0x0d0;
	public static final int Key_Ntilde = 0x0d1;
	public static final int Key_Ograve = 0x0d2;
	public static final int Key_Oacute = 0x0d3;
	public static final int Key_Ocircumflex = 0x0d4;
	public static final int Key_Otilde = 0x0d5;
	public static final int Key_Odiaeresis = 0x0d6;
	public static final int Key_multiply = 0x0d7;
	public static final int Key_Ooblique = 0x0d8;
	public static final int Key_Ugrave = 0x0d9;
	public static final int Key_Uacute = 0x0da;
	public static final int Key_Ucircumflex = 0x0db;
	public static final int Key_Udiaeresis = 0x0dc;
	public static final int Key_Yacute = 0x0dd;
	public static final int Key_THORN = 0x0de;
	public static final int Key_ssharp = 0x0df;
	public static final int Key_agrave = 0x0e0;
	public static final int Key_aacute = 0x0e1;
	public static final int Key_acircumflex = 0x0e2;
	public static final int Key_atilde = 0x0e3;
	public static final int Key_adiaeresis = 0x0e4;
	public static final int Key_aring = 0x0e5;
	public static final int Key_ae = 0x0e6;
	public static final int Key_ccedilla = 0x0e7;
	public static final int Key_egrave = 0x0e8;
	public static final int Key_eacute = 0x0e9;
	public static final int Key_ecircumflex = 0x0ea;
	public static final int Key_ediaeresis = 0x0eb;
	public static final int Key_igrave = 0x0ec;
	public static final int Key_iacute = 0x0ed;
	public static final int Key_icircumflex = 0x0ee;
	public static final int Key_idiaeresis = 0x0ef;
	public static final int Key_eth = 0x0f0;
	public static final int Key_ntilde = 0x0f1;
	public static final int Key_ograve = 0x0f2;
	public static final int Key_oacute = 0x0f3;
	public static final int Key_ocircumflex = 0x0f4;
	public static final int Key_otilde = 0x0f5;
	public static final int Key_odiaeresis = 0x0f6;
	public static final int Key_division = 0x0f7;
	public static final int Key_oslash = 0x0f8;
	public static final int Key_ugrave = 0x0f9;
	public static final int Key_uacute = 0x0fa;
	public static final int Key_ucircumflex = 0x0fb;
	public static final int Key_udiaeresis = 0x0fc;
	public static final int Key_yacute = 0x0fd;
	public static final int Key_thorn = 0x0fe;
	public static final int Key_ydiaeresis = 0x0ff;
	public static final int Key_Back = 0x1061;
	public static final int Key_Forward = 0x1062;
	public static final int Key_Stop = 0x1063;
	public static final int Key_Refresh = 0x1064;
	public static final int Key_VolumeDown = 0x1070;
	public static final int Key_VolumeMute = 0x1071;
	public static final int Key_VolumeUp = 0x1072;
	public static final int Key_BassBoost = 0x1073;
	public static final int Key_BassUp = 0x1074;
	public static final int Key_BassDown = 0x1075;
	public static final int Key_TrebleUp = 0x1076;
	public static final int Key_TrebleDown = 0x1077;
	public static final int Key_MediaPlay = 0x1080;
	public static final int Key_MediaStop = 0x1081;
	public static final int Key_MediaPrev = 0x1082;
	public static final int Key_MediaNext = 0x1083;
	public static final int Key_MediaRecord = 0x1084;
	public static final int Key_HomePage = 0x1090;
	public static final int Key_Favorites = 0x1091;
	public static final int Key_Search = 0x1092;
	public static final int Key_Standby = 0x1093;
	public static final int Key_OpenUrl = 0x1094;
	public static final int Key_LaunchMail = 0x10a0;
	public static final int Key_LaunchMedia = 0x10a1;
	public static final int Key_Launch0 = 0x10a2;
	public static final int Key_Launch1 = 0x10a3;
	public static final int Key_Launch2 = 0x10a4;
	public static final int Key_Launch3 = 0x10a5;
	public static final int Key_Launch4 = 0x10a6;
	public static final int Key_Launch5 = 0x10a7;
	public static final int Key_Launch6 = 0x10a8;
	public static final int Key_Launch7 = 0x10a9;
	public static final int Key_Launch8 = 0x10aa;
	public static final int Key_Launch9 = 0x10ab;
	public static final int Key_LaunchA = 0x10ac;
	public static final int Key_LaunchB = 0x10ad;
	public static final int Key_LaunchC = 0x10ae;
	public static final int Key_LaunchD = 0x10af;
	public static final int Key_LaunchE = 0x10b0;
	public static final int Key_LaunchF = 0x10b1;
	public static final int Key_MediaLast = 0x1fff;
	public static final int Key_unknown = 0xffff;
	public static final int UpArrow = 0;
	public static final int DownArrow = 1;
	public static final int LeftArrow = 2;
	public static final int RightArrow = 3;
	public static final int CopyROP = 0;
	public static final int OrROP = 1;
	public static final int XorROP = 2;
	public static final int NotAndROP = 3;
	public static final int EraseROP = NotAndROP;
	public static final int NotCopyROP = 4;
	public static final int NotOrROP = 5;
	public static final int NotXorROP = 6;
	public static final int AndROP = 7;
	public static final int NotEraseROP = AndROP;
	public static final int NotROP = 8;
	public static final int ClearROP = 9;
	public static final int SetROP = 10;
	public static final int NopROP = 11;
	public static final int AndNotROP = 12;
	public static final int OrNotROP = 13;
	public static final int NandROP = 14;
	public static final int NorROP = 15;
	public static final int LastROP = NorROP;
	public static final int NoPen = 0;
	public static final int SolidLine = 1;
	public static final int DashLine = 2;
	public static final int DotLine = 3;
	public static final int DashDotLine = 4;
	public static final int DashDotDotLine = 5;
	public static final int MPenStyle = 0x0f;
	public static final int FlatCap = 0x00;
	public static final int SquareCap = 0x10;
	public static final int RoundCap = 0x20;
	public static final int MPenCapStyle = 0x30;
	public static final int MiterJoin = 0x00;
	public static final int BevelJoin = 0x40;
	public static final int RoundJoin = 0x80;
	public static final int MPenJoinStyle = 0xc0;
	public static final int NoBrush = 0;
	public static final int SolidPattern = 1;
	public static final int Dense1Pattern = 2;
	public static final int Dense2Pattern = 3;
	public static final int Dense3Pattern = 4;
	public static final int Dense4Pattern = 5;
	public static final int Dense5Pattern = 6;
	public static final int Dense6Pattern = 7;
	public static final int Dense7Pattern = 8;
	public static final int HorPattern = 9;
	public static final int VerPattern = 10;
	public static final int CrossPattern = 11;
	public static final int BDiagPattern = 12;
	public static final int FDiagPattern = 13;
	public static final int DiagCrossPattern = 14;
	public static final int CustomPattern = 24;
	public static final int MV_Unknown = 0x0000;
	public static final int MV_9 = 0x0001;
	public static final int MV_10_DOT_1 = 0x0002;
	public static final int MV_10_DOT_2 = 0x0003;
	public static final int MV_JAGUAR = MV_10_DOT_2;
	public static final int WV_32s = 0x0001;
	public static final int WV_95 = 0x0002;
	public static final int WV_98 = 0x0003;
	public static final int WV_Me = 0x0004;
	public static final int WV_DOS_based = 0x000f;
	public static final int WV_NT = 0x0010;
	public static final int WV_2000 = 0x0020;
	public static final int WV_XP = 0x0030;
	public static final int WV_NT_based = 0x00f0;
	public static final int UI_General = 0;
	public static final int UI_AnimateMenu = 1;
	public static final int UI_FadeMenu = 2;
	public static final int UI_AnimateCombo = 3;
	public static final int UI_AnimateTooltip = 4;
	public static final int UI_FadeTooltip = 5;
	public static final int ArrowCursor = 0;
	public static final int UpArrowCursor = 1;
	public static final int CrossCursor = 2;
	public static final int WaitCursor = 3;
	public static final int IbeamCursor = 4;
	public static final int SizeVerCursor = 5;
	public static final int SizeHorCursor = 6;
	public static final int SizeBDiagCursor = 7;
	public static final int SizeFDiagCursor = 8;
	public static final int SizeAllCursor = 9;
	public static final int BlankCursor = 10;
	public static final int SplitVCursor = 11;
	public static final int SplitHCursor = 12;
	public static final int PointingHandCursor = 13;
	public static final int ForbiddenCursor = 14;
	public static final int WhatsThisCursor = 15;
	public static final int LastCursor = WhatsThisCursor;
	public static final int BitmapCursor = 24;
	public static final int PlainText = 0;
	public static final int RichText = 1;
	public static final int AutoText = 2;
	public static final int LogText = 3;
	public static final int AnchorName = 0;
	public static final int AnchorHref = 1;
	public static final int DockUnmanaged = 0;
	public static final int DockTornOff = 1;
	public static final int DockTop = 2;
	public static final int DockBottom = 3;
	public static final int DockRight = 4;
	public static final int DockLeft = 5;
	public static final int DockMinimized = 6;
	public static final int Unmanaged = DockUnmanaged;
	public static final int TornOff = DockTornOff;
	public static final int Top = DockTop;
	public static final int Bottom = DockBottom;
	public static final int Right = DockRight;
	public static final int Left = DockLeft;
	public static final int Minimized = DockMinimized;
	public static final int TextDate = 0;
	public static final int ISODate = 1;
	public static final int LocalDate = 2;
	public static final int LocalTime = 0;
	public static final int UTC = 1;
	public static final int FixedColor = 0;
	public static final int FixedPixmap = 1;
	public static final int NoBackground = 2;
	public static final int PaletteForeground = 3;
	public static final int PaletteButton = 4;
	public static final int PaletteLight = 5;
	public static final int PaletteMidlight = 6;
	public static final int PaletteDark = 7;
	public static final int PaletteMid = 8;
	public static final int PaletteText = 9;
	public static final int PaletteBrightText = 10;
	public static final int PaletteBase = 11;
	public static final int PaletteBackground = 12;
	public static final int PaletteShadow = 13;
	public static final int PaletteHighlight = 14;
	public static final int PaletteHighlightedText = 15;
	public static final int PaletteButtonText = 16;
	public static final int PaletteLink = 17;
	public static final int PaletteLinkVisited = 18;
	public static final int X11ParentRelative = 19;
	public static final int CaseSensitive = 0x00001;
	public static final int BeginsWith = 0x00002;
	public static final int EndsWith = 0x00004;
	public static final int Contains = 0x00008;
	public static final int ExactMatch = 0x00010;
}
